package s_com.udojava.evalex;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Iterator;
import java.util.Objects;
import s_com.udojava.evalex.Expression;

class Tokenizer implements Iterator<String> {
  private int pos = 0;
  
  private String input;
  
  private String previousToken;
  
  public Tokenizer(String input) {
    this.input = input.trim();
  }
  
  public boolean hasNext() {
    return (this.pos < this.input.length());
  }
  
  private char peekNextChar() {
    if (this.pos < this.input.length() - 1)
      return this.input.charAt(this.pos + 1); 
    return Character.MIN_VALUE;
  }
  
  public String next() {
    StringBuilder token = new StringBuilder();
    if (this.pos >= this.input.length())
      return this.previousToken = null; 
    char ch = this.input.charAt(this.pos);
    while (Character.isWhitespace(ch) && this.pos < this.input.length())
      ch = this.input.charAt(++this.pos); 
    if (Character.isDigit(ch)) {
      Objects.requireNonNull(Expression.this);
      while ((Character.isDigit(ch) || ch == '.') && this.pos < this.input.length()) {
        token.append(this.input.charAt(this.pos++));
        ch = (this.pos == this.input.length()) ? Character.MIN_VALUE : this.input.charAt(this.pos);
      } 
    } else {
      Objects.requireNonNull(Expression.this);
      if (ch == '-' && Character.isDigit(peekNextChar()) && ("(".equals(this.previousToken) || ",".equals(this.previousToken) || this.previousToken == null || Expression.this.operators.containsKey(this.previousToken))) {
        Objects.requireNonNull(Expression.this);
        token.append('-');
        this.pos++;
        token.append(next());
      } else if (Character.isLetter(ch) || ch == '_') {
        while ((Character.isLetter(ch) || Character.isDigit(ch) || ch == '_') && this.pos < this.input.length()) {
          token.append(this.input.charAt(this.pos++));
          ch = (this.pos == this.input.length()) ? Character.MIN_VALUE : this.input.charAt(this.pos);
        } 
      } else if (ch == '(' || ch == ')' || ch == ',') {
        token.append(ch);
        this.pos++;
      } else {
        while (!Character.isLetter(ch) && !Character.isDigit(ch) && ch != '_' && !Character.isWhitespace(ch) && ch != '(' && ch != ')' && ch != ',' && this.pos < this.input.length()) {
          token.append(this.input.charAt(this.pos));
          this.pos++;
          ch = (this.pos == this.input.length()) ? Character.MIN_VALUE : this.input.charAt(this.pos);
          Objects.requireNonNull(Expression.this);
          if (ch == '-')
            break; 
        } 
        if (!Expression.this.operators.containsKey(token.toString()))
          throw new Expression.ExpressionException(Expression.this, "Unknown operator '" + token + "' at position " + this.pos - token.length() + 1); 
      } 
    } 
    return this.previousToken = token.toString();
  }
  
  public void remove() {
    throw new Expression.ExpressionException(Expression.this, "remove() not supported");
  }
  
  public int getPos() {
    return this.pos;
  }
}
